
// Inclusion of library of templates di_unsigned
#include <di.h>
// Inclusion of library of standard input-output
#include <stdio.h>

// Word length of the first type
const unsigned int numberbit1=250;

// Word length of the second type
const unsigned int numberbit2=253;

// Definition of the first type
typedef di_unsigned < unsigned int, unsigned int, numberbit1 > big_digit1;

// Definition of the second type
typedef di_unsigned < unsigned int, unsigned int, numberbit2 > big_digit2;

// Use "unsigned int" as T and Tunit  

int main () {

// Length of a text string for print first number
const unsigned int l1 = ((numberbit1)/CHAR_BIT+1)*2+1;

// Length of a text string for print second number
const unsigned int l2 = ((numberbit2)/CHAR_BIT+1)*2+1;

// Text string for print first number
char string1 [l1];

// Text string for print second number
char string2 [l2];

// Initialization of three numbers
big_digit1 d1=1;
big_digit2 d2=1;
big_digit2 d3;

// left shift operator  
d1 <<= (numberbit1/2+1);
d2 <<= numberbit1/2;

// increment operator
++d1;

// print of result
d1.printtostring (string1,l2);
d2.printtostring (string2,l2);

printf (" \nd1   =0x%s ",string1);
printf (" \nd2   =0x%s ",string2);

// addition operator
d3=d1+d2;

// print of result
d3.printtostring (string2,l2);
printf ("\nd1+d2=0x%s",string2);

// multiplication operator
d3=d1*d2;

// print of result
d3.printtostring (string2,l2);
printf ("\nd1*d2=0x%s",string2);

// division operator  
d3=d1/d2;

// print of result
d3.printtostring (string2,l2);
printf ("\nd1/d2=0x%s",string2);

// modulus operator 
d3=d1%d2;

// print of result
d3.printtostring (string2,l2);
printf ("\nd1%sd2=0x%s","%",string2);

return 0;
}

