
#ifndef DIT_THIS
#define DIT_THIS

#ifdef __Borland__
#include <conio.h>
#endif

#include <stdio.h>
#include <string.h>

#include <time.h>

#include <di.h>

typedef unsigned int dit_counter;
typedef unsigned int dit_codeerr;
typedef unsigned int dit_longcounter;

const dit_codeerr dit_baseerror=0;

#define DIT_ERROR(x) const dit_codeerr dit_error##x=dit_baseerror+x;

DIT_ERROR(0)
DIT_ERROR(1)
DIT_ERROR(2)
DIT_ERROR(3)
DIT_ERROR(4)
DIT_ERROR(5)
DIT_ERROR(6)
DIT_ERROR(7)
DIT_ERROR(8)
DIT_ERROR(9)

class dit_errorbase{
static const char* message[];
dit_codeerr codeerr;
const char* ptr;
public:

dit_errorbase(dit_codeerr c,const char* p=0):
codeerr(c),ptr(p){}

dit_codeerr geterror(){return codeerr;}

virtual void release(FILE* fl){

time_t terr=time(0);

if(codeerr!=dit_baseerror)
fprintf(fl,"\nerror time=%s",ctime(&terr));

fprintf(fl,"\n");
fprintf(fl,message[codeerr]);

  if(ptr!=0){
    fprintf(fl,"\n");
    fprintf(fl,ptr);
  }//if
}
};

template<class Tcounter>
class dit_error:public dit_errorbase{
Tcounter i;
Tcounter di;
public:
dit_error(dit_codeerr c,dit_counter i1,dit_counter di1,const char* p=0):
dit_errorbase(c,p),i(i1),di(di1){}

virtual void release(FILE* fl){
dit_errorbase::release(fl);
fprintf(fl,"\ncounter=%u di=%u",i,di);
}

};

const unsigned int dit_size=13;
const unsigned int dit_size1=8;

typedef unsigned int dit_typecounter;
typedef unsigned char dit_typeunit;

typedef di_unsigned<dit_typecounter,dit_typeunit,dit_size> di1_typetest1;
typedef di_unsigned<dit_typecounter,dit_typeunit,dit_size1> di1_typetest2;
typedef
di_unsigned<dit_typecounter,dit_typeunit,dit_size+dit_size1> di1_typetest3;

#endif

